.include "m8515def.inc"



.def temp0=r16
.def temp1=r17
.def perehod=r18
.def perL=r19
.def perH=r20
.def res1=r21
.def res2=r22
.def res3=r23
.def res4=r24
.def uslov=r25

;      1FE0
.cseg
.org $0FF0
.db $46,$52,$45,$51,$55,$45,$4E,$43,$59,$20,$20,$4D,$45,$54,$45,$52
.org $0FF8
.db $20,$20,$20,$20,$20,$56,$65,$72,$2E,$30,$31,$20,$20,$20,$20,$20

;    
.org $0FE0
.db $20,$20,$20,$4D,$48,$7A,$20,$4B,$48,$7A,$20,$20,$48,$7A,$20,$20  
.org $0FE8
.db $20,$20,$20,$20,$30,$30,$20,$30,$30,$30,$20,$30,$30,$30,$20,$20

;  
.org $0FD8
.db $30,$31,$32,$33,$34,$35,$36,$37,$38,$39

.cseg
.org $00
rjmp reset


.org $02
rjmp int1_go

.org $06
rjmp timer1_go





.org $11
reset:
  ;  
  ldi temp0,LOW (ramend)
  out SPL,temp0
  ldi temp0,HIGH (ramend)
  out SPH,temp0

  ;   256 
  ldi temp0,(1<<WDCE | 1<<WDE | 1<<WDP2  | 0<<WDP1 | 0<<WDP0)
  out WDTCR,temp0
  out WDTCR,temp0
  
;  ,  .
 sbi DDRC,4
 cbi PORTC,4 
 sbi DDRC,5
 cbi PORTC,5
 sbi DDRC,6
 cbi PORTC,6
 sbi DDRC,7
 sbi PORTC,7

;    
cbi DDRB,7
cbi DDRB,6  
cbi DDRB,5
cbi DDRB,4
sbi PORTB,7
sbi PORTB,6
sbi PORTB,5
sbi PORTB,4

  ;    int0
  ;  
 ;     INT1
 ; PD3-PD7  
  sbi DDRC,3
  sbi PORTC,3
   cbi DDRD,2
   sbi PORTD,2
     cbi DDRD,3
     sbi PORTD,3 
       cbi DDRD,4
       sbi PORTD,4 
         cbi DDRD,5
         sbi PORTD,5
           cbi DDRD,6
           sbi PORTD,6
             cbi DDRD,7
             sbi PORTD,7
               ldi temp0,(1<<INT1 |0<<INT0)
               out GICR,temp0
	           ldi temp0,(1<<ISC11 | 1<<ISC10 |1<<ISC01|1 <<ISC00)
               out MCUCR,temp0
               ldi perehod,$80










                
;  
sei
  

;   +   
rcall LCD_init

;=================================
;     
  cbi PORTC,0
  cbi PORTC,1
  cbi PORTC,2
    
	ldi temp0,$80
	rcall write_LCD
    sbi PORTC,0    
    ldi r30,$E0
	ldi r31,$1F  
	ldi temp1,$10
	   loop_wr1:
         lpm temp0,Z+
		 rcall write_LCD 
         dec temp1
	   brne loop_wr1	 

    cbi PORTC,0
    ldi temp0,$C0
    rcall write_LCD
	sbi PORTC,0
	   ldi temp1,$10
	   loop_wr2:
         lpm temp0,Z+
		 rcall write_LCD 
         dec temp1
	   brne loop_wr2	

;===================================

     
;=======================================
;   
ldi temp1,$2A
  loop1:
    rcall time_100ms
	dec temp1
  brne loop1  
;=======================================



	


;=======================================
;  
start:
  wdr
;=======================================
; 
;=======================================

;=======================================
;   .   
  
   cpi perehod,$10
   breq hold
   	 cpi perehod,$80
	 breq non_hold
	    rjmp non_hold
;=======================================


;=======================================
non_hold:
  cbi PORTC,5
  cbi PORTC,4
  cbi PORTC,6 
    rcall ismer
	rcall multi
	rcall multi_16
	rcall copy
	rcall copy_data_hold
	rcall razrad
	rcall perekod
	rcall copy_LCD_HOLD
	rcall LCD
	rcall time_100ms
    rcall time_100ms
rjmp start
;=======================================


;=======================================


hold:
  clr uslov
  cbi PORTC,5
  cbi PORTC,4
  sbi PORTC,6
    cpi perehod,$80
    breq non_hold
      sbrc perehod,5
      rcall fr1
        sbrc perehod,6
	    rcall fr2
           sbrc uslov,1
		   rjmp hold
		    
		   rcall ismer
	       rcall multi
	       rcall multi_16
	       rcall copy
	       rcall razrad
	       rcall perekod
	          lds temp0,$E0
			  sts $64,temp0
		      lds temp0,$E1
			  sts $65,temp0
			    lds temp0,$E2
				sts $67,temp0
				lds temp0,$E3
				sts $68,temp0
				lds temp0,$E4
				sts $69,temp0
				  lds temp0,$E5
				  sts $6B,temp0
				    lds temp0,$E6
					sts $6C,temp0 
		              ldi temp0,$30
					  sts $6D,temp0
					  ldi temp0,$20
					  sts $63,temp0
		                 ldi temp0,$46
						 sts $60,temp0
						 ldi temp0,$72
						 sts $61,temp0
						 ldi temp0,$3A
						 sts $62,temp0
						 						  
		   rcall LCD
	       rcall time_100ms
           rcall time_100ms    

rjmp hold










;=======================================

rjmp start


;==============================================================
;           
;==============================================================

;   100
time_100us:
  wdr
  push temp0  
   ldi temp0,$09
     loop_t3:
       wdr
	   wdr
	   wdr
	   wdr
	   rcall time_10us 
	   dec temp0 
	 brne loop_t3
  pop temp0
ret


;   10 
time_10us:
  wdr
  push temp0
   ldi temp0,$16
    loop_t2:
	   dec temp0
    brne loop_t2 
   pop temp0
   nop
   nop
ret


;   100
time_100ms:
  wdr
  push temp0
  ldi temp0,$64
  loop_t5:
	    push temp0
		ldi temp0,$0A
	    loop_t4:
	   	  rcall time_100us
		  dec temp0
	    brne loop_t4  
    pop temp0
	dec temp0
	brne loop_t5
       rcall time_100us
	   rcall time_10us
	   rcall time_10us
	   rcall time_10us
	   rcall time_10us
	   rcall time_10us
       rcall time_10us
 pop temp0
ret

;  + 
LCD_init:
  wdr
  push temp0  
	rcall time_100ms
    rcall time_100ms
    rcall time_100ms
    rcall time_100ms
    rcall time_100ms  
      sbi DDRC,0
	  cbi PORTC,0 
	    sbi DDRC,1
	    cbi PORTC,1
	      sbi DDRC,2
		  cbi PORTC,2
            ldi temp0,$FF
			out DDRA,temp0
			  ldi temp0,$30
			  rcall write_LCD
			  rcall time_100ms
			     ldi temp0,$30
			     rcall write_LCD
			     rcall time_100ms
			   		ldi temp0,$30
			        rcall write_LCD
			        rcall time_100ms           
                       ldi temp0,$38
			           rcall write_LCD
			           rcall time_100ms
					      ldi temp0,$08
			                rcall write_LCD
			                rcall time_100ms
						      ldi temp0,$0E
			                  rcall write_LCD
			                  rcall time_100ms
							    ldi temp0,$06
			                    rcall write_LCD
			                    rcall time_100ms
  pop temp0
ret


;    LCD
write_LCD:
  wdr
    cbi PORTC,2
	out PORTA,temp0
	rcall time_10us
	sbi PORTC,2
	rcall time_10us
	cbi PORTC,2
	rcall time_100us
ret


;     
LCD:
  wdr

 cbi PORTC,0
  cbi PORTC,1
  cbi PORTC,2
    
	ldi temp0,$80
	rcall write_LCD
    sbi PORTC,0    
    ldi r30,$60
	ldi r31,$00  
	ldi temp1,$10
	   loop_wr3:
         ld temp0,Z+
		 rcall write_LCD 
         dec temp1
	   brne loop_wr3	 

    cbi PORTC,0
    ldi temp0,$C0
    rcall write_LCD
	sbi PORTC,0
	   ldi temp1,$10
	   loop_wr4:
         ld temp0,Z+
		 rcall write_LCD 
         dec temp1
	   brne loop_wr4
ret


;======================================
;     
copy:
  ldi temp1,$20
  ldi r31,$1F
  ldi r30,$C0
  ldi r29,$00
  ldi r28,$60
   loop_OZU:
     wdr
	 lpm temp0,Z+
	 st Y+,temp0
     dec temp1
   brne loop_OZU  
ret

;======================================



;=======================================
; 
ismer:
  wdr
  sbi DDRD,0
  sbi DDRD,1
  sbi PORTD,1
  clr r1
  clr r0
  inc r0
	clr perL
	clr perH
	sbi PORTB,1
    ldi temp0,(1<<CS12 | 1<<CS11 |1<<CS10)
	out TCCR1B,temp0
	ldi temp0,(1<<TOIE1)
    out TIMSK,temp0
    cbi PORTD,1
	ldi temp0,$00
	out TCNT1H,temp0
	out TCNT1L,temp0
	sbi PORTD,0 
	rcall time_100ms
    cbi PORTD,0
	cbi PORTB,1
	ldi temp0,(0<<CS12 |0<<CS11|0<<CS10)
	out TCCR1B,temp0 
	ldi temp0,(0<<TOIE1)
    out TIMSK,temp0
    in r11,TCNT1L
	in r12,TCNT1H
      in r6,PINB  
      lsr r6
	  lsr r6
	  lsr r6
	  lsr r6
	  mov temp0,r6
	  andi temp0,$0F 
      mov r6,temp0
	  clr r7
	  clr r8 
      clr r9
ret  
;=======================================


;      
multi:
  wdr
    ser temp0
	mov r2,temp0
	mov r3,temp0
	clr r4
    clr r5         
      clr r1
      clr r0
      inc r0
         clr res1
         clr res2
         clr res3
         clr res4  
           loop_multi:
             wdr  
	           add res1,r2
	           adc res2,r3
	           adc res3,r4
	           adc res4,r5
	             sub perL,r0
	             sbc perH,r1
            brcc loop_multi 
                    sub res1,r2
	                sbc res2,r3
                    sbc res3,r4
	                sbc res4,r5
                       add res1,r11
					   adc res2,r12
					   adc res3,r4
					   adc res4,r5
ret



;   16
multi_16:
  wdr
mov r2,res1
mov r3,res2
mov r4,res3
mov r5,res4
  clr res1
  clr res2
  clr res3
  clr res4 
  
    ldi temp0,$10
	  loop_multi_16:
	    wdr
          add res1,r2
		  adc res2,r3
		  adc res3,r4          
          adc res4,r5
	    dec temp0
	  brne loop_multi_16
         add res1,r6
		 adc res2,r7
		 adc res3,r8
		 adc res4,r9

ret 



temp:
rcall razrad
;===========================================
; 
razrad:
  wdr
    
; 1 000 000	
	ldi r28,$00
	ldi r27,$0F
	ldi r26,$42
	ldi r25,$40
	  clr temp0
	  loop_raz7:
	     wdr
          sub res1,r25
		  sbc res2,r26
		  sbc res3,r27
		  sbc res4,r28
		  inc temp0
	  brcc loop_raz7     
             dec temp0
			 add res1,r25
			 adc res2,r26
			 adc res3,r27
             adc res4,r28
             sts $A0,temp0

;100 000
    ldi r28,$00
	ldi r27,$01
	ldi r26,$86
	ldi r25,$A0
	  clr temp0
	  loop_raz6:
	     wdr
          sub res1,r25
		  sbc res2,r26
		  sbc res3,r27
		  sbc res4,r28
		  inc temp0
	  brcc loop_raz6     
             dec temp0
			 add res1,r25
			 adc res2,r26
			 adc res3,r27
             adc res4,r28
             sts $A1,temp0

; 10 000
    ldi r28,$00
	ldi r27,$00
	ldi r26,$27
	ldi r25,$10
	  clr temp0
	  loop_raz5:
	     wdr
          sub res1,r25
		  sbc res2,r26
		  sbc res3,r27
		  sbc res4,r28
		  inc temp0
	  brcc loop_raz5     
             dec temp0
			 add res1,r25
			 adc res2,r26
			 adc res3,r27
             adc res4,r28
             sts $A2,temp0

;1 000
    ldi r28,$00
	ldi r27,$00
	ldi r26,$03
	ldi r25,$E8
	  clr temp0
	  loop_raz4:
	     wdr
          sub res1,r25
		  sbc res2,r26
		  sbc res3,r27
		  sbc res4,r28
		  inc temp0
	  brcc loop_raz4     
             dec temp0
			 add res1,r25
			 adc res2,r26
			 adc res3,r27
             adc res4,r28
             sts $A3,temp0

;100
    ldi r28,$00
	ldi r27,$00
	ldi r26,$00
	ldi r25,$64
	  clr temp0
	  loop_raz3:
	     wdr
          sub res1,r25
		  sbc res2,r26
		  sbc res3,r27
		  sbc res4,r28
		  inc temp0
	  brcc loop_raz3     
             dec temp0
			 add res1,r25
			 adc res2,r26
			 adc res3,r27
             adc res4,r28
             sts $A4,temp0


;10
    ldi r28,$00
	ldi r27,$00
	ldi r26,$00
	ldi r25,$0A
	  clr temp0
	  loop_raz2:
	     wdr
          sub res1,r25
		  sbc res2,r26
		  sbc res3,r27
		  sbc res4,r28
		  inc temp0
	  brcc loop_raz2     
             dec temp0
			 add res1,r25
			 adc res2,r26
			 adc res3,r27
             adc res4,r28
             sts $A5,temp0

;1
    ldi r28,$00
	ldi r27,$00
	ldi r26,$00
	ldi r25,$01
	  clr temp0
	  loop_raz1:
	     wdr
          sub res1,r25
		  sbc res2,r26
		  sbc res3,r27
		  sbc res4,r28
		  inc temp0
	  brcc loop_raz1     
             dec temp0
			 add res1,r25
			 adc res2,r26
			 adc res3,r27
             adc res4,r28
             sts $A6,temp0


ret




perekod:
  wdr
   ldi r28,$A0   
   ldi r29,00
   ldi r31,$1F
   ldi r30,$B0
   ld temp0,Y 
   add r30,temp0
   lpm temp0,Z
   sts $B0,temp0 

   ldi r28,$A1   
   ldi r29,00
   ldi r31,$1F
   ldi r30,$B0
   ld temp0,Y 
   add r30,temp0
   lpm temp0,Z
   sts $B1,temp0 

   ldi r28,$A2   
   ldi r29,00
   ldi r31,$1F
   ldi r30,$B0
   ld temp0,Y 
   add r30,temp0
   lpm temp0,Z
   sts $B2,temp0 

   ldi r28,$A3   
   ldi r29,00
   ldi r31,$1F
   ldi r30,$B0
   ld temp0,Y 
   add r30,temp0
   lpm temp0,Z
   sts $B3,temp0 

   ldi r28,$A4   
   ldi r29,00
   ldi r31,$1F
   ldi r30,$B0
   ld temp0,Y 
   add r30,temp0
   lpm temp0,Z
   sts $B4,temp0 

   ldi r28,$A5   
   ldi r29,00
   ldi r31,$1F
   ldi r30,$B0
   ld temp0,Y 
   add r30,temp0
   lpm temp0,Z
   sts $B5,temp0 

   ldi r28,$A6   
   ldi r29,00
   ldi r31,$1F
   ldi r30,$B0
   ld temp0,Y 
   add r30,temp0
   lpm temp0,Z
   sts $B6,temp0 

   lds temp0,$B0
   sts $74,temp0
   lds temp0,$B1
   sts $75,temp0

   lds temp0,$B2
   sts $77,temp0
   lds temp0,$B3
   sts $78,temp0
   lds temp0,$B4
   sts $79,temp0


   lds temp0,$B5
   sts $7B,temp0
   lds temp0,$B6
   sts $7C,temp0

ret


;    hold
copy_data_hold:
  wdr
            sts $D0,res1
			sts $D1,res2
			sts $D2,res3
			sts $D3,res4
ret


;    hold
copy_LCD_HOLD:
  wdr
    lds temp0,$B0
	sts $E0,temp0
	  lds temp0,$B1
	  sts $E1,temp0
	    lds temp0,$B2
		sts $E2,temp0
		  lds temp0,$B3
		  sts $E3,temp0
		    lds temp0,$B4
			sts $E4,temp0
			  lds temp0,$B5
			  sts $E5,temp0
			    lds temp0,$B6
				sts $E6,temp0 

ret


summa:
  wdr
  add res1,r6
  adc res2,r7
  adc res3,r8
  adc res4,r9 
ret

vivod:
  wdr
           rcall copy
	       rcall razrad
	       rcall perekod
	          lds temp0,$E0
			  sts $64,temp0
		      lds temp0,$E1
			  sts $65,temp0
			    lds temp0,$E2
				sts $67,temp0
				lds temp0,$E3
				sts $68,temp0
				lds temp0,$E4
				sts $69,temp0
				  lds temp0,$E5
				  sts $6B,temp0
				    lds temp0,$E6
					sts $6C,temp0 
		              ldi temp0,$30
					  sts $6D,temp0
					  ldi temp0,$20
					  sts $63,temp0
		                 ldi temp0,$46
						 sts $60,temp0
						 ldi temp0,$72
						 sts $61,temp0
						 ldi temp0,$3A
						 sts $62,temp0
						 ldi temp0,$22
						 sts $70,temp0
						 sts $72,temp0
						 ldi temp0,$2B
						 sts $71,temp0
						  
		   rcall LCD
	       rcall time_100ms
           rcall time_100ms    

ret


zapis:
  wdr
    lds r6,$D0
    lds r7,$D1
    lds r8,$D2
    lds r9,$D3 
ret



fr1:
  wdr
  sbi PORTC,5
  cbi PORTC,4
  sbi PORTC,6
      
    rcall ismer
	rcall multi
	rcall multi_16
	rcall copy
	rcall zapis
	rcall summa
	rcall vivod
	
 ser uslov 
ret




fr2:
  wdr
  ldi temp0,$20
  sts $140,temp0
  cbi PORTC,5
  sbi PORTC,4
  sbi PORTC,6
    rcall ismer
	rcall multi
	rcall multi_16
	rcall copy
    rcall zapis  
	  sub res1,r6
	  sbc res2,r7
	  sbc res3,r8
	  sbc res4,r9
         brcs carry  
         ca:
		 rcall copy
	       rcall razrad
	       rcall perekod
	          lds temp0,$E0
			  sts $64,temp0
		      lds temp0,$E1
			  sts $65,temp0
			    lds temp0,$E2
				sts $67,temp0
				lds temp0,$E3
				sts $68,temp0
				lds temp0,$E4
				sts $69,temp0
				  lds temp0,$E5
				  sts $6B,temp0
				    lds temp0,$E6
					sts $6C,temp0 
		              ldi temp0,$30
					  sts $6D,temp0
					  ldi temp0,$20
					  sts $63,temp0
		                 ldi temp0,$46
						 sts $60,temp0
						 ldi temp0,$72
						 sts $61,temp0
						 ldi temp0,$3A
						 sts $62,temp0
						 ldi temp0,$22
						 sts $70,temp0
						 sts $72,temp0
						 ldi temp0,$2D
						 sts $71,temp0
						 lds temp0,$140
						 sts $73,temp0

						  
		   rcall LCD
	       rcall time_100ms
           rcall time_100ms    		 
  ser uslov
ret


carry:
  wdr
    add res1,r6
	adc res2,r7
	adc res3,r8
	adc res4,r9
	  sub r6,res1
      sbc r7,res2
	  sbc r8,res3
	  sbc r9,res4
	    mov res1,r6
		mov res2,r7
		mov res3,r8
		mov res4,r9
          ldi temp0,$2D
		  sts $140,temp0
rjmp ca


;==========================================


;==============================================================
; 
;==============================================================

int1_go:
  wdr
  push temp0
  in temp0,SREG
  push temp0
     in perehod,PIND
	 andi perehod,$F0
  pop temp0
  out SREG,temp0
  pop temp0
reti


timer1_go:
   push temp0
   in temp0,SREG 
   push temp0
     add perL,r0
     adc perH,r1
   pop temp0
   out SREG,temp0
   pop temp0
reti

